#include "OutilsSpecifiques.h"
#include "Regle.h"
#include <iostream>
using std::cout;
using std::endl;

void VaAGauche::entrer()
{
   cout << "Tourner vers la gauche" << endl;
}
void VaAGauche::dedans()
{
   EtatMouvement::dedans();
   cout << "Aller vers la gauche" << endl;
}
void VaAGauche::sortir()
{
   cout << "Arreter d'aller vers la gauche" << endl;
}

void VaADroite::entrer()
{
   cout << "Tourner vers la droite" << endl;
}
void VaADroite::dedans()
{
   EtatMouvement::dedans();
   cout << "Aller vers la droite" << endl;
}
void VaADroite::sortir()
{
   cout << "Arreter d'aller vers la droite" << endl;
}

void AutomateAllerRetour::construire()
{
   PtrPartage<Pas> p(new Pas);
   PtrPartage<Etat> p0(new VaAGauche(p));
   PtrPartage<Etat> p1(new VaADroite(p));
   PtrPartage<Transition> tG(new Transition(p0));
   PtrPartage<Transition> tD(new Transition(p1));
   PtrPartage<Predicat> pred0(new ChangementDirection);
   PtrPartage<Predicat> pred1(new Essouflement);
   tG->ajouter(new Regle(pred1));
   tG->ajouter(new Regle(pred0, tD));
   tD->ajouter(new Regle(pred1));
   tD->ajouter(new Regle(pred0, tG));
   ajouter(p0).ajouter(p1).ajouter(tG).ajouter(tD);
}


